#!/bin/sh

######################################
#Turds!
OPENSSL=openssl-1.0.1g
BDB=db-4.8.30
BOOST=boost_1_52_0
######################################

DIST=$(readlink -f ./distfiles)
OURLIBS=$(readlink -f ./ourlibs)

export CC=$(readlink -f ../toolchain/usr/bin/x86_64-therealbitcoin-linux-musl-gcc)
export CXX=$(readlink -f ../toolchain/usr/bin/x86_64-therealbitcoin-linux-musl-g++)
export LD=$(readlink -f ../toolchain/usr/bin/x86_64-therealbitcoin-linux-musl-ld)

export CFLAGS=-I$(readlink -f ../toolchain/usr/include)
export LDFLAGS=-L$(readlink -f ../toolchain/usr/lib)
export PATH=$PATH:$(readlink -f ../toolchain/usr/bin)

tar xvfz $DIST/$OPENSSL.tar.gz;
cd $OPENSSL;
patch -p1 < ../openssl-004-musl-termios.patch
./Configure --prefix=$OURLIBS no-dso threads linux-x86_64 && make && make install_sw;
cd ..;

tar xvfz $DIST/$BDB.tar.gz;
cd $BDB/build_unix;
../dist/configure --enable-cxx --prefix=$OURLIBS &&
make &&
make install &&
cd ../..;

tar xvjf $DIST/$BOOST.tar.bz2;
cd $BOOST;
echo "using gcc : : $CXX ;" >> tools/build/v2/user-config.jam;
./bootstrap.sh;
./bjam toolset=gcc link=static -sNO_BZIP2=1 -sNO_ZLIB=1 -sNO_COMPRESSION=1;
./bjam toolset=gcc link=static --prefix=$OURLIBS install;
cd ..;

export BOOST_INCLUDE_PATH=$OURLIBS/include
export BDB_INCLUDE_PATH=$OURLIBS/include
export OPENSSL_INCLUDE_PATH=$OURLIBS/include
export BOOST_LIB_PATH=$OURLIBS/lib
export BDB_LIB_PATH=$OURLIBS/lib
export OPENSSL_LIB_PATH=$OURLIBS/lib

cd bitcoin/bitcoin/src;
make STATIC=all -f makefile.unix bitcoind
strip bitcoind
